Handling Validation in Smart Paste Button

24 Sep 202421 minutes to read

The Smart Paste Button can be configured to validate that all required input form fields have been pasted with content. If any form fields are empty, validation will be triggered to ensure that all necessary information is provided before proceeding.

let options = {
    rules: {
        'bug-name': { required: true },
        'reporter-name': { required: true },
        'submit-date': { required: true },
        'bug-description': { required: true },
        'reproduce-steps': { required: true },
        'browser': { required: true }
    }
}
let formObject = new ej.inputs.FormValidator('#form-element', options);

let externalSubmit = () => {
  // Validate the form from external validate method
  let formStatus = formObject.validate();
  if (formStatus) {
    formObject.element.reset();
  }
};

document.getElementById('smart-paste').addEventListener('mousedown', externalSubmit);

let inputobj1 = new ej.inputs.TextBox({
  placeholder: "What's the bug ?",
  floatLabelType: "Never",
});
inputobj1.appendTo("#bug-name");

let inputobj2 = new ej.inputs.TextBox({
  placeholder: "Who is the reporter ?",
  floatLabelType: "Never",
});
inputobj2.appendTo("#reporter-name");

let inputobj3 = new ej.inputs.TextBox({
  placeholder: "When it is reported ?",
  floatLabelType: "Never",
});
inputobj3.appendTo("#submitted-date");

let textArea1 = new ej.inputs.TextArea({
  placeholder: "Describe a little about the bug.",
  rows: 2,
  floatLabelType: "Never",
});
textArea1.appendTo("#bug-description");

let textArea2 = new ej.inputs.TextArea({
  placeholder: "Enter the repro steps here..",
  cols: 30,
  rows: 4,
  floatLabelType: "Never",
});
textArea2.appendTo("#reproduce-steps");

let radioButton = new ej.buttons.RadioButton({
  label: "Low",
  name: "bug-priority",
  value: "low"
});
radioButton.appendTo("#radio1");

radioButton = new ej.buttons.RadioButton({
  label: "Medium",
  name: "bug-priority",
  value: "medium",
  checked: true
});
radioButton.appendTo("#radio2");

radioButton = new ej.buttons.RadioButton({
  label: "High",
  name: "bug-priority",
  value: "high",
});
radioButton.appendTo("#radio3");

const browserData = [
  'Chrome', 'Firefox', 'Safari'
];
let comboBoxObj = new ej.dropdowns.ComboBox({
  popupHeight: '230px',
  dataSource: browserData,
  placeholder: 'Choose the browser',
});
comboBoxObj.appendTo('#browser');

// Initialize Button control.
let resetButton = new ej.buttons.Button({
  content: 'Reset',
  iconCss: "e-icons e-reset",
});
// Render initialized Button.
resetButton.appendTo('#reset');

const serverAIRequest = async (options) => {
  let output = '';
  try {
    // console.log("input:", options);
    output = await (window).AzureAIRequest(options);
    output = output.replace('END_RESPONSE', '')
    // console.log("Success:", output);
  } catch (error) {
    console.error("Error:", error);
  }
  return output;
};

// Initialize Smart Paste Button control.
let button = new ej.buttons.SmartPasteButton({
  content: 'Smart Paste',
  iconCss: "e-icons e-paste",
  aiAssistHandler: serverAIRequest
});
// Render initialized Smart Paste Button.
button.appendTo('#smart-paste');

// Property Pane Code

let bugPresets = [
  "Issue with the dropdown menu",
  "Trouble logging into the website",
  "Search functionality not working",
  "Images missing on the product page"
];

let bugReports = [
  `Hi, this is Alice. On July 3rd, I've come across a bug where the dropdown menu in the navigation bar doesn't close after selecting an item. I just navigated to the homepage, opened the dropdown menu in the navigation bar, clicked an item in the dropdown and then the issue occurred which happens only on Chrome. Though this doesn't seem like a serious/important bug, kindly look into it and resolve it. Regards, J Alice Abraham`,
  `Hey team, On May 2nd, K John Doe reported an issue where the login page refreshes instead of logging in when the user clicks the login button. This problem prevents users from accessing their accounts, making it a critical issue that needs immediate attention. The issue has been observed across all major browsers. To reproduce the issue, open any browser and navigate to the website's login page. Enter a valid username and password, then click the Login button.`,
  `Hi, Whenever I type something in the search bar and hit search, it doesn't return any results, even for items I know exist. This problem was noticed by Jane Smith on July 5th in FireFox browser. You can repro the issue by opening the site in the Firefox browser and navigate to the search bar. Type in any search term, including items that are known to exist, and click the search button. The search functionality fails to return any results, displaying an empty result set even for valid queries. This is quite important, but not urgent. Please look into it. Regards, M William Marker`,
  `Hello, When I selected the category option on the landing page and chose the electronics category, the images were missing on the product page. The placeholders are there, but no actual images are loading. This happens on all browsers. I reported this on July 3rd. It's not urgent, but it does affect the user experience. Regards, L Mike Johnson`
];

let copyContent = document.getElementById('bug-report-text');
copyContent.innerHTML = bugReports[0];

let copyButton = new ej.buttons.Button({
  content: 'Copy',
  iconCss: "e-icons e-copy"
});
copyButton.appendTo('#copy-btn');

copyButton.element.onclick = async () => {
  await navigator.clipboard.writeText(copyContent.innerHTML);
  copyButton.content = "Copied";
  copyButton.iconCss = "e-icons e-check";
}

let chipList = new ej.buttons.ChipList({
  chips: bugPresets,
  selection: 'Single',
  selectedChips: [0],
  click: (e) => {
    copyContent.innerHTML = bugReports[e.index];
    chipList.selectedChips = e.index;
    copyButton.content = "Copy";
    copyButton.iconCss = "e-icons e-copy";
  }
}, '#chip-choice');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Floating Action Button</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="styles.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/32.1.19/dist/ej2.min.js" type="text/javascript"></script>
<script src="./azure_openai.js" type="module"></script>
<style>
    .form-container {
        display: flex;
        flex-direction: column;
        gap: 15px;
        border: 1px solid #ddd;
        padding: 20px;
        border-radius: 5px;
        width: 49%;
        margin: 0 auto;
    }

    .form-label {
        margin-bottom: 5px;
    }

    .form-input,
    .form-textarea,
    .form-select {
        padding: 10px;
        border: 1px solid #ccc;
        border-radius: 3px;
        width: 100%;
    }

    .form-textarea {
        height: 80px;
    }


    .row-group {
        display: grid;
        grid-template-columns: repeat(2, 1fr);
        gap: 10px;
    }

    .form-footer {
        display: flex;
        margin-top: 20px;
        justify-content: right;
        gap: 15px;
    }

    .form-group {
        display: grid;
        gap: 8px;
    }

    .single-row-group {
        display: grid;
        gap: 8px;
    }

    #bug-report-text {
        padding: 10px;
        margin: 15px 0px;
        background-color: #f3f3f3;
        border: 1px solid #ddd;
        border-radius: 5px;
        line-height: 1.5;
    }

    #reset,
    #smart-paste {
        border-radius: 20px;
    }
</style>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <h2>Data Form with Syncfusion Smart Paste Button</h2>
        <form class="form-container" id="form-element">
            <div class="single-row-group">
                <label for="bug-name" class="e-form-label">Bug Name</label>
                <input type="text" id="bug-name" name="bug-name" class="form-input" />
            </div>
    
            <div class="row-group">
                <div>
                    <label for="reporter-name" class="e-form-label">Reporter</label>
                    <input type="text" id="reporter-name" name="reporter-name" class="form-input" />
                </div>
                <div>
                    <label for="submitted-date" class="e-form-label">Submitted Date</label>
                    <input type="text" id="submitted-date" name="submit-date" class="form-input" />
                </div>
            </div>
    
            <div class="form-group">
                <label for="bug-description" class="e-form-label">Bug Description</label>
                <textarea id="bug-description" class="form-textarea"></textarea>
            </div>
    
            <div class="row-group">
                <div style="display: flex;flex-direction: column;">
                    <label for="reproduce-steps" class="e-form-label">Reproduce Steps</label>
                    <textarea id="reproduce-steps" name="reproduce-steps" class="form-textarea"></textarea>
                </div>
                <div>
                    <label class="form-label">Bug Priority</label>
                    <div class="row">
                        <input id="radio1" type="radio">
                    </div>
                    <div class="row">
                        <input id="radio2" type="radio">
                    </div>
                    <div class="row">
                        <input id="radio3" type="radio">
                    </div>
                </div>
    
            </div>
    
            <div>
                <label for="browser" class="form-label">Select the browser</label>
                <input type="text" id="browser" name="browser" />
            </div>
    
            <div class="form-footer">
                <button type="reset" id="reset" class="form-button"></button>
                <button type="button" id="smart-paste" class="form-button"></button>
            </div>
        </form>
    
        <div class="col-lg-4 property-section">
            <div class="property-panel-section">
                <div class="property-panel-content">
                    <h4> Choose a preset below </h4>
                    <div class="chip-container">
                        <div id="chip-choice" aria-label="choiceChips"></div>
                    </div>
                    <div id="bug-report-text"></div>
                    <button id="copy-btn"></button>
                </div>
            </div>
        </div>    
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>
import { AzureOpenAI } from "https://cdn.jsdelivr.net/npm/[email protected]/+esm";
 
//Warning: Do not expose your API key in the client-side code. This is only for demonstration purposes.

// Replace your Azure OpenAI endpoint, apiVersion, deployment and API key here
const endpoint = "AZURE_OPENAI_ENDPOINT";
const apiKey = "AZURE_OPENAI_API_KEY";
const deployment = "DEPLOYMENT_NAME";
const apiVersion = "API_VERSION";
 
const client = new AzureOpenAI({
    endpoint,
    apiKey,
    apiVersion,
    deployment,
    dangerouslyAllowBrowser: true
});
 
window.AzureAIRequest = async function (options) {
    try {
        const result = await client.chat.completions.create({
            messages: options.messages,
            model: "",
            top_p: options.topP,
            temperature: options.temperature,
            max_tokens: options.maxTokens,
            frequency_penalty: options.frequencyPenalty,
            presence_penalty: options.presencePenalty,
            stop: options.stopSequences
        });
        return result.choices[0].message.content;
    } catch (err) {
        console.error("Error occurred:", err);
    }
}

Handling Validation in Smart Paste Button

25 Apr 202517 minutes to read

The Smart Paste Button can be configured to validate that all required input form fields have been pasted with content. If any form fields are empty, validation will be triggered to ensure that all necessary information is provided before proceeding.

<template>
  <div id='container'>
    <h2 id="paste-title">Data Form with Syncfusion Smart Paste Button</h2>
    <form class="form-container">
      <div class="single-row-group">
        <label for="bug-name" class="e-form-label">Bug Name</label>
        <ejs-textbox id="bug-name" name="bug-name" cssClass="form-input" placeholder="What's the bug ?"
          floatLabelType="Never"></ejs-textbox>
      </div>

      <div class="row-group">
        <div>
          <label for="reporter-name" class="e-form-label">Reporter</label>
          <ejs-textbox id="reporter-name" name="reporter-name" cssClass="form-input" placeholder="Who is the reporter ?"
            floatLabelType="Never"
            data-smartpaste-description="Name must follow the format: Initial Firstname Lastname"></ejs-textbox>
        </div>
        <div>
          <label for="submitted-date" class="e-form-label">Submitted Date</label>
          <ejs-textbox id="submitted-date" name="submit-date" cssClass="form-input" placeholder="When it is reported ?"
            floatLabelType="Never"
            data-smartpaste-description="Date must follow the format: Month Day. For ex: May 01"></ejs-textbox>
        </div>
      </div>

      <div class="form-group">
        <label for="bug-description" class="e-form-label">Bug Description</label>
        <ejs-textarea id="bug-description" cssClass="form-textarea" placeholder="Describe a little about the bug"
          rows="2" floatLabelType="Never"></ejs-textarea>
      </div>

      <div class="row-group">
        <div style="display: flex; flex-direction: column;">
          <label for="reproduce-steps" class="e-form-label">Reproduce Steps</label>
          <ejs-textarea id="reproduce-steps" name="reproduce-steps" cssClass="form-textarea" cols='30' rows="4"
            placeholder="Enter the repro steps here.." floatLabelType="Never"
            data-smartpaste-description="Structure each steps in a Numbered format."></ejs-textarea>
        </div>
        <div>
          <label class="form-label">Bug Priority</label>
          <div class="row">
            <ejs-radiobutton id="radio1" value="low" name="bug-priority" label="Low" checked=true></ejs-radiobutton>
          </div>
          <div class="row">
            <ejs-radiobutton id="radio2" value="medium" name="bug-priority" label="Medium"></ejs-radiobutton>

          </div>
          <div class="row">
            <ejs-radiobutton id="radio3" value="high" name="bug-priority" label="High"></ejs-radiobutton>
          </div>
        </div>

      </div>

      <div>
        <label for="browser" class="form-label">Select the browser</label>
        <ejs-combobox id="browser" name="browser" :dataSource="browserData"
          placeholder='Choose the browser'></ejs-combobox>
      </div>

      <div class="form-footer">
        <ejs-button id="reset" cssClass="form-button" content="Reset" iconCss="e-icons e-reset"></ejs-button>
        <ejs-smartpastebutton id="smart-paste" cssClass="form-button" iconCss="e-icons e-paste" content="Smart Paste"
          :aiAssistHandler="serverAIRequest" @mousedown="externalSubmit"></ejs-smartpastebutton>
      </div>
    </form>

    <div class="col-lg-4 property-section">
      <div class="property-panel-section">
        <div class="property-panel-content">
          <h4> Choose a preset below </h4>
          <div class="chip-container">
            <ejs-chiplist id="chip-choice" :chips="bugPresets" selection='Single' :selectedChips="selectedChips"
              @click="onChipClick"></ejs-chiplist>
          </div>
          <div id="bug-report-text"></div>
          <ejs-button ref="copyRef" id="copy-btn" content="Copy" iconCss="e-icons e-copy" @click="copy"></ejs-button>
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { SmartPasteButtonComponent, ChatOptions, ButtonComponent, RadioButtonComponent, ChipListComponent } from "@syncfusion/ej2-vue-buttons";
import { TextBoxComponent, TextAreaComponent, FormValidator, FormValidatorModel } from "@syncfusion/ej2-vue-inputs";
import { ComboBoxComponent } from "@syncfusion/ej2-vue-dropdowns";
import { getAzureChatAIRequest } from './ai-model';

export default {
  name: 'App',
  components: {
    'ejs-smartpastebutton': SmartPasteButtonComponent,
    'ejs-button': ButtonComponent,
    'ejs-textbox': TextBoxComponent,
    'ejs-textarea': TextAreaComponent,
    'ejs-radiobutton': RadioButtonComponent,
    'ejs-combobox': ComboBoxComponent,
    'ejs-chiplist': ChipListComponent
  },
  data() {
    return {
      formObject: null,
      browserData: ['Chrome', 'Firefox', 'Safari'],
      selectedChips: null,
      bugPresets: [
        "Issue with the dropdown menu",
        "Trouble logging into the website",
        "Search functionality not working",
        "Images missing on the product page"
      ],
      bugReports: [
        `Hi, this is Alice. On July 3rd, I've come across a bug where the dropdown menu in the navigation bar doesn't close after selecting an item. I just navigated to the homepage, opened the dropdown menu in the navigation bar, clicked an item in the dropdown and then the issue occurred which happens only on Chrome. Though this doesn't seem like a serious/important bug, kindly look into it and resolve it. Regards, J Alice Abraham`,
        `Hey team, On May 2nd, K John Doe reported an issue where the login page refreshes instead of logging in when the user clicks the login button. This problem prevents users from accessing their accounts, making it a critical issue that needs immediate attention. The issue has been observed across all major browsers. To reproduce the issue, open any browser and navigate to the website's login page. Enter a valid username and password, then click the Login button.`,
        `Hi, Whenever I type something in the search bar and hit search, it doesn't return any results, even for items I know exist. This problem was noticed by Jane Smith on July 5th in FireFox browser. You can repro the issue by opening the site in the Firefox browser and navigate to the search bar. Type in any search term, including items that are known to exist, and click the search button. The search functionality fails to return any results, displaying an empty result set even for valid queries. This is quite important, but not urgent. Please look into it. Regards, M William Marker`,
        `Hello, When I selected the category option on the landing page and chose the electronics category, the images were missing on the product page. The placeholders are there, but no actual images are loading. This happens on all browsers. I reported this on July 3rd. It's not urgent, but it does affect the user experience. Regards, L Mike Johnson`
      ]
    }
  },
  methods: {
    serverAIRequest: async (options: any) => {
      let output: string | null = '';
      try {
        output = await getAzureChatAIRequest(options) as string;
        output = output.replace('END_RESPONSE', '')
      } catch (error) {
        console.error("Error:", error);
      }
      return output;
    },
    copy: async function () {
      const btn = this.$refs.copyRef.ej2Instances;
      const copyContent = document.getElementById('bug-report-text');
      if (copyContent) {
        await navigator.clipboard.writeText(copyContent.innerHTML);
        btn.content = "Copied";
        btn.iconCss = "e-icons e-check";
      }
    },
    onChipClick: function (e) {
      const copyContent = document.getElementById('bug-report-text');
      copyContent.innerHTML = this.bugReports[e.index];
      this.selectedChips = [e.index];
      this.buttonContent = "Copy";
      this.buttonIcon = "e-icons e-copy";
    },
    externalSubmit: function () {
      let formStatus = this.formObject.validate();
      if (formStatus) {
        formObject.element.reset();
      }
    }
  },
  mounted() {
    var options = {
      rules: {
        'bug-name': { required: true },
        'reporter-name': { required: true },
        'submit-date': { required: true },
        'bug-description': { required: true },
        'reproduce-steps': { required: true },
        'browser': { required: true }
      }
    };
    this.formObject = new FormValidator("#form-element", options);
  }
}
</script>

<style>

@import './style.css'

</style>
import { generateText } from "ai"
import { createAzure } from '@ai-sdk/azure';
import { createGoogleGenerativeAI } from '@ai-sdk/google';

//Replace API_KEY and resourceName
const azure = createAzure({
    resourceName: 'ej2smart',
    apiKey: 'API_KEY',
});

const google = createGoogleGenerativeAI({
    baseURL: "https://generativelanguage.googleapis.com/v1beta",
    apiKey: "API_KEY"
});
 
const aiModel = azure('e.g: gpt4-o'); // update the model here

export async function getAzureChatAIRequest(options) {
    try {
        const result = await generateText({
            model: aiModel,
            messages: options.messages,
            topP: options.topP,
            temperature: options.temperature,
            maxTokens: options.maxTokens,
            frequencyPenalty: options.frequencyPenalty,
            presencePenalty: options.presencePenalty,
            stopSequences: options.stopSequences
        });
        return result.text;
    } catch (err) {
        console.error("Error occurred:", err);
        return null;
    }
}
#paste-title {
  text-align: center;
}
.form-container {
  display: flex;
  flex-direction: column;
  gap: 15px;
  border: 1px solid #ddd;
  padding: 20px;
  border-radius: 5px;
  width: 49%;
  margin: 0 auto;
}

.form-label {
  margin-bottom: 5px;
}

.form-input,
.form-textarea,
.form-select {
  padding: 10px;
  border: 1px solid #ccc;
  border-radius: 3px;
  width: 100%;
}

.form-textarea {
  height: 80px;
}

.row-group {
  display: grid;
  grid-template-columns: repeat(2, 1fr);
  gap: 10px;
}

.form-footer {
  display: flex;
  margin-top: 20px;
  justify-content: right;
  gap: 15px;
}

.form-group {
  display: grid;
  gap: 8px;
}

.single-row-group {
  display: grid;
  gap: 8px;
}

#bug-report-text {
  padding: 10px;
  margin: 15px 0px;
  background-color: #f3f3f3;
  border: 1px solid #ddd;
  border-radius: 5px;
  line-height: 1.5;
}

#reset,
#smart-paste {
  border-radius: 20px;
}

Below is the featured sample output:

vue-3-js-smart-paste-button

See also

Handling Validation in Smart Paste Button

6 Apr 202520 minutes to read

The Smart Paste Button can be configured to validate that all required input form fields have been pasted with content. If any form fields are empty, validation will be triggered to ensure that all necessary information is provided before proceeding.

import { Component, OnInit, viewChild, ViewChild} from '@angular/core';
import { FormBuilder, FormGroup } from '@angular/forms';
import {ButtonComponent, ButtonAllModule, SmartPasteButtonAllModule , RadioButtonAllModule, ChipListModule, ClickEventArgs } from '@syncfusion/ej2-angular-buttons';
import {  ComboBoxModule} from '@syncfusion/ej2-angular-dropdowns';
import { TextAreaAllModule,TextBoxAllModule, FormValidatorModel, FormValidator } from '@syncfusion/ej2-angular-inputs';
import {DatePickerAllModule} from '@syncfusion/ej2-angular-calendars';
import { getAzureChatAIRequest } from './ai-model';
import { VirtualElementHandler } from '@syncfusion/ej2-angular-grids';
import { createSpinner, showSpinner } from '@syncfusion/ej2-angular-popups';

@Component({
  selector: 'app-smart-paste',
  standalone: true,
  imports: [ButtonAllModule, ChipListModule,TextBoxAllModule,RadioButtonAllModule,SmartPasteButtonAllModule,ComboBoxModule, TextAreaAllModule,DatePickerAllModule],
  templateUrl: './smart-paste.component.html',
  styleUrls: ['./smart-paste.component.css']
})
export class SmartPasteComponent implements OnInit {
  @ViewChild('smart') public smartPaste: any;
  @ViewChild('copyButton1', { static: true } ) public copyButton1!: ButtonComponent;
  @ViewChild('copyButton2', { static: true } ) public copyButton2!: ButtonComponent;
  public buttonInstance: { [key: string]: HTMLElement | null } = {};
  public idArray: string[] = ['1', '2'];
  public formObject: FormValidator | undefined;
  bugForm!: FormGroup;
  browsers: string[] = ['Chrome', 'Firefox', 'Edge', 'Safari'];

  constructor(private fb: FormBuilder) {}

  ngOnInit(): void {

    const options: FormValidatorModel = {
      rules: {
        'bug-name': { required: [true] },
        'reporter-name': { required: [true] },
        'submitted-date': { required: [true] },
        'bug-description': { required: [true] },
        'reproduce-steps': { required: [true] },
        'browser': { required: [true] }
      },
    };

    this.formObject = new FormValidator('#ai-bug-form', options);

    this.bugForm = this.fb.group({
      bugName: [''],
      reporterName: [''],
      submittedDate: [''],
      bugDescription: [''],
      reproduceSteps: [''],
      bugPriority: [''],
      browser: ['']
    });
    this.buttonInstance = {
      button1: this.copyButton1.element,
      button2: this.copyButton2.element,
  };

  document.querySelector('#reproduce-steps')!.addEventListener('change', () => {
    (this as any).formObject.validate();
  });
  
  }
// Property Pane Code

 public bugPresets: string[] = [
  "Issue with the dropdown menu",
  "Trouble logging into the website",
  "Search functionality not working",
  "Images missing on the product page"
];

public  bugReports: string[] = [
  `Hi, this is Alice. On July 3rd, I've come across a bug where the dropdown menu in the navigation bar doesn't close after selecting an item. I just navigated to the homepage, opened the dropdown menu in the navigation bar, clicked an item in the dropdown and then the issue occurred which happens only on Chrome. Though this doesn't seem like a serious/important bug, kindly look into it and resolve it. Regards, J Alice Abraham`,
  `Hey team, On May 2nd, K John Doe reported an issue where the login page refreshes instead of logging in when the user clicks the login button. This problem prevents users from accessing their accounts, making it a critical issue that needs immediate attention. The issue has been observed across all major browsers. To reproduce the issue, open any browser and navigate to the website's login page. Enter a valid username and password, then click the Login button.`,
  `Hi, Whenever I type something in the search bar and hit search, it doesn't return any results, even for items I know exist. This problem was noticed by Jane Smith on July 5th in FireFox browser. You can repro the issue by opening the site in the Firefox browser and navigate to the search bar. Type in any search term, including items that are known to exist, and click the search button. The search functionality fails to return any results, displaying an empty result set even for valid queries. This is quite important, but not urgent. Please look into it. Regards, M William Marker`,
  `Hello, When I selected the category option on the landing page and chose the electronics category, the images were missing on the product page. The placeholders are there, but no actual images are loading. This happens on all browsers. I reported this on July 3rd. It's not urgent, but it does affect the user experience. Regards, L Mike Johnson`
];

  onReset(): void {
    this.bugForm.reset();
  }
  
public serverAIRequest = async (settings: any) => {
  let output = '';
  try {
      console.log(settings);
      const response = await getAzureChatAIRequest(settings) as string;
      console.log("Success:", response);
      output = response;
  } catch (error) {
      console.error("Error:", error);
  }
  return output;
};
  onCreated(): void {
    this.smartPaste.aiAssistHandler = this.serverAIRequest;
  }

async copyContent(id: string) {
  if (!document.hasFocus()) {
    window.focus(); // Bring the document into focus
  }
  let text = document.getElementById('copy-content' + id)?.innerText;
  await navigator.clipboard.writeText(text as string);
  let inactive: string = this.idArray.filter((item) => item !== id)[0];
  this.buttonInstance['button' + inactive]?.querySelector('span')?.classList.replace('e-check', 'e-copy');
  this.buttonInstance['button' + id]?.querySelector('span')?.classList.replace('e-copy', 'e-check');
}
  
}
<h2 style="text-align:center;">Data Smart Paste Button</h2>

<h3 style="text-align:center;">Bug Report</h3>
<div class="description-container e-card">
  <div class='e-card-content'>
    <p>
      The <b>SmartPasteButton</b> is an AI-powered upgrade of Syncfusion's Button, adding smart pasting
      features. It uses AI to paste clipboard data in the right context and format automatically.
  </p>
  <p>
      To quickly fill out the bug report form, copy the sample content and click the Smart Paste button. Know
      more <a href="https://github.com/syncfusion/smart-ai-samples/blob/master/typescript/src/app/smartpaste/Readme.md">here</a>.
  </p>
  </div>
</div>

<form id="ai-bug-form" class="form-container container bug-form-container" style="max-width: 900px; line-height: 35px; background-color: #f3f4f6;">
  <div style="text-align:center;"><span>Bug Report Form</span></div>
  <div class="single-row-group">
    <label for="bug-name" class="e-form-label">Bug Name</label>
    <ejs-textbox id="bug-name" name="bug-name" formControlName="bugName" cssClass="form-input"></ejs-textbox>
  </div>

  <div class="row-group">
    <div>
      <label for="reporter-name" class="e-form-label">Reporter</label>
      <ejs-textbox id="reporter-name" name="reporter-name" formControlName="reporterName" cssClass="form-input"></ejs-textbox>
    </div>
    <div>
      <label for="submitted-date" class="e-form-label">Submitted Date</label>
      <ejs-textbox id="submitted-date" name="submit-date" formControlName="submittedDate" cssClass="form-input"></ejs-textbox>
    </div>
  </div>

  <div class="form-group">
    <label for="bug-description" class="e-form-label">Bug Description</label>
    <ejs-textarea id="bug-description" formControlName="bugDescription" cssClass="form-textarea" multiline="true" placeholder="Describe a little about the bug."></ejs-textarea>
  </div>

  <div class="row-group">
    <div style="display: flex; flex-direction: column;">
      <label for="reproduce-steps" class="e-form-label">Reproduce Steps</label>
      <ejs-textbox id="reproduce-steps" name="reproduce-steps" formControlName="reproduceSteps" cssClass="form-textarea" multiline="true"></ejs-textbox>
    </div>
    <div>
      <label class="form-label">Bug Priority</label>
      <div class="row">
        <ejs-radiobutton id="radio1" label="Low" name="bugPriority" formControlName="bugPriority" value="Low"></ejs-radiobutton>
      </div>
      <div class="row">
        <ejs-radiobutton id="radio2" label="Medium" name="bugPriority" formControlName="bugPriority" value="Medium" [checked]="true"></ejs-radiobutton>
      </div>
      <div class="row">
        <ejs-radiobutton id="radio3" label="High" name="bugPriority" formControlName="bugPriority" value="High"></ejs-radiobutton>
      </div>
    </div>
  </div>

  <div>
    <label for="browser" class="form-label">Select the browser</label>
    <ejs-combobox id="browser" name="browser" formControlName="browser" [dataSource]="browsers"  placeholder="Choose the browser"></ejs-combobox>
  </div>

  <div class="form-footer">
    <button ejs-button type="reset" id="reset" iconCss="e-icons e-reset" cssClass="form-button" (click)="onReset()">Reset</button>
    <button #smart ejs-smart-paste-button  type="button" id="smart-paste" iconCss="e-icons e-paste" cssClass="form-button" (created)="onCreated()">Smart Paste</button>
  </div>
</form>

<div class="col-lg-12 property-section" style="padding-top: 5px;">
  <h4 style="text-align: center; font-size: 1.2rem;">Sample content</h4>
  <div class="content-flexed">
    <div class="content-body" data-index="0">
      <div class="copy-container" style="float: right;">
        <button #copyButton1 ejs-button id="copy1" (click)="copyContent('1')" cssClass="e-control e-btn e-lib custom-copy-icon e-primary e-icon-btn">
          <span class="e-icons e-copy e-btn-icon"></span>
        </button>
      </div>
      <div id="copy-content1">
        Hi, this is Alice. On July 3rd, I've come across a bug where the dropdown menu in the navigation bar doesn't close after selecting an item. I just navigated to the homepage, opened the dropdown menu in the navigation bar, clicked an item in the dropdown, and then the issue occurred, which happens only on Chrome. Though this doesn't seem like a serious/important bug, kindly look into it and resolve it. Regards, J Alice Abraham
      </div>
    </div>

    <div class="content-body" data-index="1">
      <div class="copy-container" style="float: right;">
        <button #copyButton2 ejs-button id="copy2" (click)="copyContent('2')" cssClass="e-control e-btn e-lib custom-copy-icon e-primary e-icon-btn">
          <span class="e-icons e-copy e-btn-icon"></span>
        </button>
      </div>
      <div id="copy-content2">
        Hi, Whenever I type something in the search bar and hit search, it doesn't return any results, even for items I know exist. This problem was noticed by Jane Smith on July 5th in FireFox browser. You can repro the issue by opening the site in the Firefox browser and navigating to the search bar. Type in any search term, including items that are known to exist, and click the search button. The search functionality fails to return any results, displaying an empty result set even for valid queries. This is quite important, but not urgent. Please look into it. Regards, M William Marker.
      </div>
    </div>
  </div>
#ai-bug-form .e-valid-input {
    border-color: #4CAF50;
}

.form-container {
    display: flex;
    flex-direction: column;
    gap: 15px;
    border: 1px solid #ddd;
    padding: 20px;
    border-radius: 5px;
    width: 700px;
    margin: 0 auto;
}

.form-label {
    margin-bottom: 5px;
}

.form-input,
.form-textarea,
.form-select {
    padding: 10px;
    border: 1px solid #ccc;
    border-radius: 3px;
    width: 100%;
}

.form-textarea {
    height: 80px;
}


.row-group {
    display: grid;
    grid-template-columns: repeat(2, 1fr);
    gap: 10px;
}

.form-footer {
    display: flex;
    margin-top: 20px;
    justify-content: right;
    gap: 15px;
}

.form-group {
    display: grid;
    gap: 8px;
}

.single-row-group {
    display: grid;
    gap: 8px;
}

#bug-report-text {
    padding: 10px;
    margin: 15px 0px;
    background-color: #f3f3f3;
    border: 1px solid #ddd;
    border-radius: 5px;
    line-height: 1.5;
}

#reset,
#smart-paste {
    border-radius: 20px;
}

.content-body {
    line-height: 28px;
    font-size: 14px;
    max-width: 49%;
    border-radius: 10px;
    padding: 20px;
    border: 2px solid rgb(229 231 235 / var(--border-opacity));
    --border-opacity: 1;
}

.e-btn.e-icon-btn.custom-copy-icon {
    padding: 4px;
    font-size: 10px;
}

.e-btn.custom-copy-icon:focus {
    box-shadow: none;
}

.bug-form-container {
    position: relative;
    border-radius: 20px;
    padding: 15px;
    border: 2px solid rgb(229 231 235 / var(--border-opacity));
    --border-opacity: 1;
    max-width: 600px;
}

.bug-report {
    padding: 10px;
    margin: 15px 0px;
    background-color: #f3f3f3;
    border: 1px solid #ddd;
    border-radius: 5px;
    line-height: 1.5;
}


.content-flexed {
    display: flex;
    margin-top: 20px;
    gap: 14px;
}
import { generateText } from "ai"
import { createAzure } from '@ai-sdk/azure';
import { createGoogleGenerativeAI } from '@ai-sdk/google';

//Replace API_KEY and resourceName
const azure = createAzure({
    resourceName: 'ej2smart',
    apiKey: 'API_KEY',
});

const google = createGoogleGenerativeAI({
    baseURL: "https://generativelanguage.googleapis.com/v1beta",
    apiKey: "API_KEY"
});
 
const aiModel = azure('e.g: gpt4-o'); // update the model here

export async function getAzureChatAIRequest(options) {
    try {
        const result = await generateText({
            model: aiModel,
            messages: options.messages,
            topP: options.topP,
            temperature: options.temperature,
            maxTokens: options.maxTokens,
            frequencyPenalty: options.frequencyPenalty,
            presencePenalty: options.presencePenalty,
            stopSequences: options.stopSequences
        });
        return result.text;
    } catch (err) {
        console.error("Error occurred:", err);
        return null;
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { appConfig } from './app/app.config';
import { AppComponent } from './app/app.component';

bootstrapApplication(AppComponent, appConfig)
  .catch((err) => console.error(err));

Below is the featured sample output:

Angular-smart-paste-button

See also

Handling Validation in Smart Paste Button

8 Oct 202524 minutes to read

The Smart Paste Button can be configured to validate that all required input form fields have been pasted with content. If any form fields are empty, validation will be triggered to ensure that all necessary information is provided before proceeding.

import { useEffect } from 'react';
import { ButtonComponent, ChatOptions, SmartPasteButtonComponent } from "@syncfusion/ej2-react-buttons";
import { TextBoxComponent, TextAreaComponent, FormValidator, FormValidatorModel } from "@syncfusion/ej2-react-inputs";
import { RadioButtonComponent } from "@syncfusion/ej2-react-buttons";
import { ComboBoxComponent } from "@syncfusion/ej2-react-dropdowns";
import { getAzureChatAIRequest } from './ai-models';
import { createSpinner, hideSpinner, showSpinner } from '@syncfusion/ej2-react-popups';
import './smart-paste.css';

function SmartPasteValidation() {
    let formObject: FormValidator;
    useEffect(() => {
        const options: FormValidatorModel = {
            // validation rules
            rules: {
                'bug-name': {
                    required: [true],
                },
                'reporter-name': {
                    required: [true],
                },
                'submitted-date': {
                    required: [true],
                },
                'bug-description': {
                    required: [true],
                },
                'reproduce-steps': {
                    required: [true]
                },
                'browser': {
                    required: [true]
                }

            },
        };
        // Initialize the form validator
        formObject = new FormValidator('#ai-bug-form', options);
        createSpinner({
            target: document.getElementById('bug-form')!,
        });
        buttonInstance = {
            button1: copyButton1.element,
            button2: copyButton2.element,
        };
        (document.querySelector('#reproduce-steps') as HTMLElement).addEventListener('change', () => {
            hideSpinner(document.getElementById('bug-form') as HTMLElement);
            formObject.validate();
        });
    }, []);
    let buttonInstance: { [key: string]: HTMLElement | null } = {};
    const idArray: string[] = ['1', '2'];
    let copyButton1: ButtonComponent;
    let copyButton2: ButtonComponent;

    const serverAIRequest = async (options: ChatOptions) => {
        let output: string = '';
        try {
            output = await getAzureChatAIRequest(options) as string;
        } catch (error) {
            console.error("Error:", error);
        }
        return output;
    };

    const smartPasteClickHandler = () => {
        showSpinner(document.getElementById('bug-form') as HTMLElement);
    }

    async function copyContent(id: string) {
        let text = document.getElementById('copy-content' + id)?.innerText;
        await navigator.clipboard.writeText(text as string);
        let inactive: string = idArray.filter((item) => item !== id)[0];
        buttonInstance['button' + inactive]?.querySelector('span')?.classList.replace('e-check', 'e-copy');
        buttonInstance['button' + id]?.querySelector('span')?.classList.replace('e-copy', 'e-check');
    }

    return (
        <>
            <div id="bug-form">
                <form id="ai-bug-form" className="form-container container bug-form-container" style=>
                    <div className="single-row-group">
                        <label htmlFor="bug-name" className="e-form-label">Bug Name</label>
                        <TextBoxComponent id="bug-name" placeholder="What's the bug ?" floatLabelType="Never" />
                    </div>
                    <div className="row-group">
                        <div>
                            <label htmlFor="reporter-name" className="e-form-label">Reporter</label>
                            <TextBoxComponent id="reporter-name" placeholder="Who is the reporter ?" floatLabelType="Never" />
                        </div>
                        <div>
                            <label htmlFor="submitted-date" className="e-form-label">Submitted Date</label>
                            <TextBoxComponent id="submitted-date" placeholder="When it is reported ?" floatLabelType="Never" />
                        </div>
                    </div>
                    <div className="form-group">
                        <label htmlFor="bug-description" className="e-form-label">Bug Description</label>
                        <TextAreaComponent id="bug-description" placeholder="Describe a little about the bug." rows={2} floatLabelType="Never" />
                    </div>
                    <div className="row-group">
                        <div style=>
                            <label htmlFor="browser" className="form-label">Select the browser</label>
                            <ComboBoxComponent id="browser" popupHeight='230px' dataSource={['Chrome', 'Firefox', 'Safari']} placeholder='Choose the browser' />
                        </div>

                        <div>
                            <label className="form-label">Bug Priority</label>
                            <div className="row">
                                <RadioButtonComponent id="radio1" label="Low" name="bug-priority" value="low" />
                            </div>
                            <div className="row">
                                <RadioButtonComponent id="radio2" label="Medium" name="bug-priority" value="medium" checked={true} />
                            </div>
                            <div className="row">
                                <RadioButtonComponent id="radio3" label="High" name="bug-priority" value="high" />
                            </div>
                        </div>
                    </div>
                    <div>
                        <label htmlFor="reproduce-steps" className="e-form-label">Reproduce Steps</label>
                        <TextAreaComponent id="reproduce-steps" placeholder="Enter the repro steps here.." cols={30} rows={4} floatLabelType="Never" />
                    </div>
                    <div className="form-footer">
                        <ButtonComponent type="reset" id="reset" content="Reset" iconCss="e-icons e-reset" className="form-button" />
                        <SmartPasteButtonComponent type="button" id="smart-paste" className="form-button"
                            isPrimary={true}
                            content={'Smart Paste'}
                            iconCss={"e-icons e-paste"}
                            onClick={smartPasteClickHandler}
                            aiAssistHandler={serverAIRequest} />
                    </div>
                </form>
            </div>

            <div className="col-lg-12 property-section" style=>
                <h4 style=> Sample content </h4>
                <div className="content-flexed">
                    <div className="content-body" data-index="0">
                        <div className="copy-container" style=>
                            <ButtonComponent ref={btn => copyButton1 = btn as ButtonComponent} id="copy1" onClick={() => copyContent('1')} aria-label="content-copy-button" className="e-control e-btn e-lib custom-copy-icon e-primary e-icon-btn">
                                <span className="e-icons e-copy e-btn-icon"></span>
                            </ButtonComponent>
                        </div>
                        <div id="copy-content1">
                            Hi, this is Alice. On July 3rd, I've come across a bug where the dropdown menu in the navigation bar doesn't close after selecting an item. I just navigated to the homepage, opened the dropdown menu in the navigation bar, clicked an item in the dropdown and then the issue occurred which happens only on Chrome. Though this doesn't seem like a serious/important bug, kindly look into it and resolve it. Regards, J Alice Abraham
                        </div>
                    </div>
                    <div className="content-body" data-index="1">
                        <div className="copy-container" style=>
                            <ButtonComponent ref={btn => copyButton2 = btn as ButtonComponent} id="copy2" onClick={() => copyContent('2')} aria-label="content-copy-button" className="e-control e-btn e-lib custom-copy-icon e-primary e-icon-btn">
                                <span className="e-icons e-copy e-btn-icon"></span>
                            </ButtonComponent>
                        </div>
                        <div id="copy-content2">
                            Hi, Whenever I type something in the search bar and hit search, it doesn't return any results, even for items I know exist. This problem was noticed by Jane Smith on July 5th in FireFox browser. You can repro the issue by opening the site in the Firefox browser and navigate to the search bar. Type in any search term, including items that are known to exist, and click the search button. The search functionality fails to return any results, displaying an empty result set even for valid queries. This is quite important, but not urgent. Please look into it. Regards, M William Marker.
                        </div>
                    </div>
                </div>
            </div>
        </>
    )
}

export default SmartPasteValidation
import { generateText } from "ai"
import { createGoogleGenerativeAI } from '@ai-sdk/google';
import { createAzure } from '@ai-sdk/azure';
import { createOpenAI } from '@ai-sdk/openai';

//Warning: Do not expose your API key in the client-side code. This is only for demonstration purposes.

const google = createGoogleGenerativeAI({
    baseURL: "https://generativelanguage.googleapis.com/v1beta",
    apiKey: "API_KEY"
});
const azure = createAzure({
    resourceName: 'RESOURCE_NAME',
    apiKey: 'API_KEY',
});
const groq = createOpenAI({
    baseURL: 'https://api.groq.com/openai/v1',
    apiKey: 'API_KEY',
});

const aiModel = azure('MODEL_NAME'); // Update the model here

export async function getAzureChatAIRequest(options: any) {
    try {
        const result = await generateText({
            model: aiModel,
            messages: options.messages,
            topP: options.topP,
            temperature: options.temperature,
            maxTokens: options.maxTokens,
            frequencyPenalty: options.frequencyPenalty,
            presencePenalty: options.presencePenalty,
            stopSequences: options.stopSequences
        });
        return result.text;
    } catch (err) {
        console.error("Error occurred:", err);
        return null;
    }
}
.form-container {
    display: flex;
    flex-direction: column;
    gap: 15px;
    border: 1px solid #ddd;
    padding: 20px;
    border-radius: 5px;
    width: 700px;
    margin: 0 auto;
}

.form-label {
    margin-bottom: 5px;
}

.form-input,
.form-textarea,
.form-select {
    padding: 10px;
    border: 1px solid #ccc;
    border-radius: 3px;
    width: 100%;
}

.form-textarea {
    height: 80px;
}

.content-body {
    line-height: 28px;
    font-size: 14px;
    max-width: 49%;
    border-radius: 10px;
    padding: 20px;
    border: 2px solid rgb(229 231 235 / var(--border-opacity));
    --border-opacity: 1;
}

.row-group {
    display: grid;
    grid-template-columns: repeat(2, 1fr);
    gap: 10px;
}

.form-footer {
    display: flex;
    margin-top: 20px;
    justify-content: right;
    gap: 15px;
}

.form-group {
    display: grid;
    gap: 8px;
}

.single-row-group {
    display: grid;
    gap: 8px;
}

#bug-report-text {
    padding: 10px;
    margin: 15px 0px;
    background-color: #f3f3f3;
    border: 1px solid #ddd;
    border-radius: 5px;
    line-height: 1.5;
}

#reset,
#smart-paste {
    border-radius: 20px;
}

.e-btn.e-icon-btn.custom-copy-icon {
    padding: 4px;
    font-size: 10px;
}

.e-btn.custom-copy-icon:focus {
    box-shadow: none;
}

.bug-form-container {
    position: relative;
    border-radius: 20px;
    padding: 15px;
    border: 2px solid rgb(229 231 235 / var(--border-opacity));
    --border-opacity: 1;
    max-width: 600px;
}

.bug-report {
    padding: 10px;
    margin: 15px 0px;
    background-color: #f3f3f3;
    border: 1px solid #ddd;
    border-radius: 5px;
    line-height: 1.5;
}


.content-flexed {
    display: flex;
    margin-top: 20px;
    gap: 14px;
}

#ai-bug-form .e-valid-input {
    border-color: #4CAF50;
}

Smart Paste Button with Form validation